/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */

#include "KeosResource.h"
#include "KeosResourceManager.h"

namespace Keos
{
    //=======================================================================
    // CResource implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    IResource::IResource() :
    m_strName    (""),
    m_nRefCount(1)
    {

    }

    //-----------------------------------------------------------------------
    IResource::~IResource()
    {
        if (m_strName != "")
            CResourceManager::Instance().Remove(m_strName);
    }

    //-----------------------------------------------------------------------
    const String& IResource::GetName() const
    {
        return m_strName;
    }

    //-----------------------------------------------------------------------
    void IResource::AddRef()
    {
        ++m_nRefCount;
    }

    //-----------------------------------------------------------------------
    int IResource::Release()
    {
        int nRefCount = --m_nRefCount;

        if (nRefCount == 0)
            delete this;

        return nRefCount;
    }

} // namespace Keos
